// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0

package queries

import (
	"context"
	"database/sql"
	"fmt"
)

type DBTX interface {
	ExecContext(context.Context, string, ...interface{}) (sql.Result, error)
	PrepareContext(context.Context, string) (*sql.Stmt, error)
	QueryContext(context.Context, string, ...interface{}) (*sql.Rows, error)
	QueryRowContext(context.Context, string, ...interface{}) *sql.Row
}

func New(db DBTX) *Queries {
	return &Queries{db: db}
}

func Prepare(ctx context.Context, db DBTX) (*Queries, error) {
	q := Queries{db: db}
	var err error
	if q.samenvoegingGetStmt, err = db.PrepareContext(ctx, samenvoegingGet); err != nil {
		return nil, fmt.Errorf("error preparing query SamenvoegingGet: %w", err)
	}
	if q.samenvoegingInsertStmt, err = db.PrepareContext(ctx, samenvoegingInsert); err != nil {
		return nil, fmt.Errorf("error preparing query SamenvoegingInsert: %w", err)
	}
	if q.vreemdelingCountStmt, err = db.PrepareContext(ctx, vreemdelingCount); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingCount: %w", err)
	}
	if q.vreemdelingCreateStmt, err = db.PrepareContext(ctx, vreemdelingCreate); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingCreate: %w", err)
	}
	if q.vreemdelingDeleteByIdStmt, err = db.PrepareContext(ctx, vreemdelingDeleteById); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingDeleteById: %w", err)
	}
	if q.vreemdelingDeleteByNummerStmt, err = db.PrepareContext(ctx, vreemdelingDeleteByNummer); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingDeleteByNummer: %w", err)
	}
	if q.vreemdelingGetByIdStmt, err = db.PrepareContext(ctx, vreemdelingGetById); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingGetById: %w", err)
	}
	if q.vreemdelingGetByNummerStmt, err = db.PrepareContext(ctx, vreemdelingGetByNummer); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingGetByNummer: %w", err)
	}
	if q.vreemdelingSearchByNameAndBirthdateStmt, err = db.PrepareContext(ctx, vreemdelingSearchByNameAndBirthdate); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingSearchByNameAndBirthdate: %w", err)
	}
	if q.vreemdelingUpdateByIdStmt, err = db.PrepareContext(ctx, vreemdelingUpdateById); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingUpdateById: %w", err)
	}
	if q.vreemdelingUpdateByNummerStmt, err = db.PrepareContext(ctx, vreemdelingUpdateByNummer); err != nil {
		return nil, fmt.Errorf("error preparing query VreemdelingUpdateByNummer: %w", err)
	}
	return &q, nil
}

func (q *Queries) Close() error {
	var err error
	if q.samenvoegingGetStmt != nil {
		if cerr := q.samenvoegingGetStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing samenvoegingGetStmt: %w", cerr)
		}
	}
	if q.samenvoegingInsertStmt != nil {
		if cerr := q.samenvoegingInsertStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing samenvoegingInsertStmt: %w", cerr)
		}
	}
	if q.vreemdelingCountStmt != nil {
		if cerr := q.vreemdelingCountStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingCountStmt: %w", cerr)
		}
	}
	if q.vreemdelingCreateStmt != nil {
		if cerr := q.vreemdelingCreateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingCreateStmt: %w", cerr)
		}
	}
	if q.vreemdelingDeleteByIdStmt != nil {
		if cerr := q.vreemdelingDeleteByIdStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingDeleteByIdStmt: %w", cerr)
		}
	}
	if q.vreemdelingDeleteByNummerStmt != nil {
		if cerr := q.vreemdelingDeleteByNummerStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingDeleteByNummerStmt: %w", cerr)
		}
	}
	if q.vreemdelingGetByIdStmt != nil {
		if cerr := q.vreemdelingGetByIdStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingGetByIdStmt: %w", cerr)
		}
	}
	if q.vreemdelingGetByNummerStmt != nil {
		if cerr := q.vreemdelingGetByNummerStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingGetByNummerStmt: %w", cerr)
		}
	}
	if q.vreemdelingSearchByNameAndBirthdateStmt != nil {
		if cerr := q.vreemdelingSearchByNameAndBirthdateStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingSearchByNameAndBirthdateStmt: %w", cerr)
		}
	}
	if q.vreemdelingUpdateByIdStmt != nil {
		if cerr := q.vreemdelingUpdateByIdStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingUpdateByIdStmt: %w", cerr)
		}
	}
	if q.vreemdelingUpdateByNummerStmt != nil {
		if cerr := q.vreemdelingUpdateByNummerStmt.Close(); cerr != nil {
			err = fmt.Errorf("error closing vreemdelingUpdateByNummerStmt: %w", cerr)
		}
	}
	return err
}

func (q *Queries) exec(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (sql.Result, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).ExecContext(ctx, args...)
	case stmt != nil:
		return stmt.ExecContext(ctx, args...)
	default:
		return q.db.ExecContext(ctx, query, args...)
	}
}

func (q *Queries) query(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) (*sql.Rows, error) {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryContext(ctx, args...)
	default:
		return q.db.QueryContext(ctx, query, args...)
	}
}

func (q *Queries) queryRow(ctx context.Context, stmt *sql.Stmt, query string, args ...interface{}) *sql.Row {
	switch {
	case stmt != nil && q.tx != nil:
		return q.tx.StmtContext(ctx, stmt).QueryRowContext(ctx, args...)
	case stmt != nil:
		return stmt.QueryRowContext(ctx, args...)
	default:
		return q.db.QueryRowContext(ctx, query, args...)
	}
}

type Queries struct {
	db                                      DBTX
	tx                                      *sql.Tx
	samenvoegingGetStmt                     *sql.Stmt
	samenvoegingInsertStmt                  *sql.Stmt
	vreemdelingCountStmt                    *sql.Stmt
	vreemdelingCreateStmt                   *sql.Stmt
	vreemdelingDeleteByIdStmt               *sql.Stmt
	vreemdelingDeleteByNummerStmt           *sql.Stmt
	vreemdelingGetByIdStmt                  *sql.Stmt
	vreemdelingGetByNummerStmt              *sql.Stmt
	vreemdelingSearchByNameAndBirthdateStmt *sql.Stmt
	vreemdelingUpdateByIdStmt               *sql.Stmt
	vreemdelingUpdateByNummerStmt           *sql.Stmt
}

func (q *Queries) WithTx(tx *sql.Tx) *Queries {
	return &Queries{
		db:                                      tx,
		tx:                                      tx,
		samenvoegingGetStmt:                     q.samenvoegingGetStmt,
		samenvoegingInsertStmt:                  q.samenvoegingInsertStmt,
		vreemdelingCountStmt:                    q.vreemdelingCountStmt,
		vreemdelingCreateStmt:                   q.vreemdelingCreateStmt,
		vreemdelingDeleteByIdStmt:               q.vreemdelingDeleteByIdStmt,
		vreemdelingDeleteByNummerStmt:           q.vreemdelingDeleteByNummerStmt,
		vreemdelingGetByIdStmt:                  q.vreemdelingGetByIdStmt,
		vreemdelingGetByNummerStmt:              q.vreemdelingGetByNummerStmt,
		vreemdelingSearchByNameAndBirthdateStmt: q.vreemdelingSearchByNameAndBirthdateStmt,
		vreemdelingUpdateByIdStmt:               q.vreemdelingUpdateByIdStmt,
		vreemdelingUpdateByNummerStmt:           q.vreemdelingUpdateByNummerStmt,
	}
}
